#!/bin/python

from Tkinter import *

# Fret:
Xpos=[53,90,158,222,284,344,402,456,507,555,600,645,685,723,759]
YE=[106,107,109,111,114,115,116,118,119,120,121,122,123,124,124]
YA=[91,92,93,94,95,96,97,98,99,101,102,103,104,105,106]
YD=[78,78,79,80,80,81,82,82,83,84,84,85,86,86,87]
YG=[64,64,64,65,65,65,66,66,66,67,67,68,68,69,69]
YH=[50,50,50,50,50,50,50,51,51,51,51,51,51,51,51]
Ye=[39,39,37,37,36,36,35,35,34,34,34,33,32,32,32]

# Tones:
FES=E=  [(Xpos[0],YE[0]),(Xpos[12],YE[12]),(Xpos[7],YA[7]),(Xpos[2],YD[2]),
        (Xpos[14],YD[14]),(Xpos[9],YG[9]),(Xpos[5],YH[5]),(Xpos[0],Ye[0]),(Xpos[12],Ye[12])]
EIS=F=  [(Xpos[1],YE[1]),(Xpos[13],YE[13]),(Xpos[8],YA[8]),(Xpos[3],YD[3]),
        (Xpos[10],YG[10]),(Xpos[6],YH[6]),(Xpos[1],Ye[1]),(Xpos[13],Ye[13])]
GES=FIS=[(Xpos[2],YE[2]),(Xpos[14],YE[14]),(Xpos[9],YA[9]),(Xpos[4],YD[4]),
        (Xpos[11],YG[11]),(Xpos[7],YH[7]),(Xpos[2],Ye[2]),(Xpos[14],Ye[14])]
G=      [(Xpos[3],YE[3]),(Xpos[0],YG[0]),(Xpos[10],YA[10]),(Xpos[5],YD[5]),
        (Xpos[12],YG[12]),(Xpos[8],YH[8]),(Xpos[3],Ye[3])]
GIS=AS= [(Xpos[4],YE[4]),(Xpos[1],YG[1]),(Xpos[11],YA[11]),(Xpos[6],YD[6]),
        (Xpos[13],YG[13]),(Xpos[9],YH[9]),(Xpos[4],Ye[4])]
A=      [(Xpos[5],YE[5]),(Xpos[2],YG[2]),(Xpos[12],YA[12]),(Xpos[0],YA[0]),(Xpos[7],YD[7]),
        (Xpos[14],YG[14]),(Xpos[10],YH[10]),(Xpos[5],Ye[5])]
AIS=B=  [(Xpos[6],YE[6]),(Xpos[3],YG[3]),(Xpos[13],YA[13]),(Xpos[1],YA[1]),
        (Xpos[8],YD[8]),(Xpos[11],YH[11]),(Xpos[6],Ye[6])]
H=CES=  [(Xpos[7],YE[7]),(Xpos[4],YG[4]),(Xpos[14],YA[14]),(Xpos[2],YA[2]),
        (Xpos[9],YD[9]),(Xpos[12],YH[12]),(Xpos[7],Ye[7]),(Xpos[0],YH[0])]
C=HIS=  [(Xpos[8],YE[8]),(Xpos[5],YG[5]),(Xpos[3],YA[3]),(Xpos[1],YH[1]),
        (Xpos[10],YD[10]),(Xpos[13],YH[13]),(Xpos[8],Ye[8])]
CIS=DES=[(Xpos[9],YE[9]),(Xpos[6],YG[6]),(Xpos[4],YA[4]),(Xpos[2],YH[2]),
        (Xpos[11],YD[11]),(Xpos[14],YH[14]),(Xpos[9],Ye[9])]
D=      [(Xpos[10],YE[10]),(Xpos[7],YG[7]),(Xpos[5],YA[5]),(Xpos[3],YH[3]),
        (Xpos[12],YD[12]),(Xpos[0],YD[0]),(Xpos[10],Ye[10])]
DIS=ES= [(Xpos[11],YE[11]),(Xpos[8],YG[8]),(Xpos[6],YA[6]),(Xpos[4],YH[4]),
        (Xpos[13],YD[13]),(Xpos[1],YD[1]),(Xpos[11],Ye[11])]

TONECYC=[E,F,FIS,G,GIS,A,B,H,C,CIS,D,DIS,E,F,FIS,G,GIS,A,B,H,C,CIS,D,DIS]
TONEMAP={'B#': HIS, 'C' : C, 'C#': CIS, 'Db': DES, 'D': D, 'D#':DIS, 'Eb': ES, 'E' : E, 'E#': EIS, 'F': F,
         'F#': FIS, 'Gb': GES, 'G':G, 'G#': GIS, 'Ab': AS, 'A': A, 'A#': AIS, 'Bb': B, 'B': H}

#print TONEMAP['B#']

# Scales: Extern
def readscales():
    s={}
    ch={}
    for l in file('App/config.txt'):
        try:
            a,b,c = l.split(':')
            l=c.split(',')
            if a=='s':
                s[b]=map(int,l)
            elif a=='c':
                ch[b]=map(int,l)
            else:
                print "Your Configfile is corrupted!"
        except:
            pass
    return [s,ch]

Scales,Chords=readscales()

COLOR="red"

# Helpers:

def buildscale(t,sl):
    r=[]
    n=TONECYC.index(t)
    r.append(TONECYC[n])
    for e in sl:
        n+=e
        r.append(TONECYC[n])
    return r

def frame(root, side):
    w=Frame(root)
    w.pack(side=side, expand=YES, fill=BOTH)
    return w

# MainClass:
class Scale(Toplevel):
    def __init__(self):
        Toplevel.__init__(self)
        self.actuell=[]
        self.createWidgets()

    def createWidgets(self):
        # Fret
        self.tf=frame(self, TOP)
        self.img=PhotoImage(file='App/fret.gif')
        x=self.img.width()
        y=self.img.height()
        self.fret=Canvas(self.tf, width=x, height=y)
        self.fret.create_image(0, 0, image=self.img, anchor=NW)
        self.fret.pack()
        
    def bobbel(self,x,y,color):
        return self.fret.create_oval(x-7,y-5,x+7,y+5,fill=color)

    def dotone(self,l,color):
        for e in l:
            x,y=e
            self.actuell.append(self.bobbel(x,y,color))

    def doscale(self,l,color):
        for t in l:
            self.dotone(t,color)

    def clear(self):
        for e in self.actuell:
            self.fret.delete(e)
        self.actuell=[]

    def doit(self,tone,scale):
        self.title('Scale View '+tone+" "+ scale)
        self.doscale(buildscale(TONEMAP[tone],Scales[scale]), COLOR)

    def cdoit(self,tone,chord):
        self.title('Chord View '+tone+" "+ chord)
        self.doscale(buildscale(TONEMAP[tone],Chords[chord]), COLOR)


class Chordselect(Toplevel):
    def __init__(self):
        Toplevel.__init__(self)
        self.frets=[]
        self.title('Chord Applicaltion')
        self.createWidgets()
        
    def createWidgets(self):
        # Welcomefame
        self.wellcomefr=frame(self, TOP)
        self.wellcomefr.pack()
        self.welcome=Label(self.wellcomefr, text="Select Basetone and Type. Then hit 'Show'")
        self.welcome.pack()
        # Inputframe
        self.inputfr=frame(self, TOP)
        self.inputfr.pack()
        # Inputframe
        self.inputfr=frame(self, TOP)
        self.inputfr.pack()
        # Tonebox
        self.toneboxfr=frame(self.inputfr, LEFT)
        self.toneboxfr.pack()
        self.toneselectionvar=IntVar()
        tl=TONEMAP.keys()
        tl.sort()
        li=0
        self.tonemaper={}
        for e in tl:
            Radiobutton(self.toneboxfr, text=e, value=li, variable=self.toneselectionvar).pack(anchor=W)
            self.tonemaper[li]=e
            li+=1
        # Chordbox
        self.chordboxfr=frame(self.inputfr, LEFT)
        self.chordboxfr.pack()
        self.chordselectionvar=IntVar()
        tl=Chords.keys()
        tl.sort()
        li=0
        self.chordmaper={}
        for e in tl:
            Radiobutton(self.chordboxfr, text=e, value=li, variable=self.chordselectionvar).pack(anchor=W)
            self.chordmaper[li]=e
            li+=1
        # Buttons
        self.showbutton=Button(self,text='Show', command=self.show)
        self.showbutton.pack(side=LEFT)
        self.quitbuttton=Button(self, text='Quit', command=self.master.quit)
        self.quitbuttton.pack(side=RIGHT)

    def show(self):
        x=Scale()
        x.cdoit(self.tonemaper[self.toneselectionvar.get()],self.chordmaper[self.chordselectionvar.get()])
        self.frets.append(x)


class Scaleselect(Frame):
    def __init__(self):
        Frame.__init__(self)
        self.frets=[]
        self.pack(expand=YES)
        self.master.title('Scale Application')
        self.createWidgets()
        
    def createWidgets(self):
        # Welcomefame
        self.wellcomefr=frame(self, TOP)
        self.wellcomefr.pack()
        self.welcome=Label(self.wellcomefr, text="Select Basetone and Type. Then hit 'Show'")
        self.welcome.pack()
        # Inputframe
        self.inputfr=frame(self, TOP)
        self.inputfr.pack()
        # Tonebox
        self.toneboxfr=frame(self.inputfr, LEFT)
        self.toneboxfr.pack()
        self.toneselectionvar=IntVar()
        tl=TONEMAP.keys()
        tl.sort()
        li=0
        self.tonemaper={}
        for e in tl:
            Radiobutton(self.toneboxfr, text=e, value=li, variable=self.toneselectionvar).pack(anchor=W)
            self.tonemaper[li]=e
            li+=1
        # Scalebox
        self.scaleboxfr=frame(self.inputfr, LEFT)
        self.scaleboxfr.pack()
        self.scaleselectionvar=IntVar()
        tl=Scales.keys()
        tl.sort()
        li=0
        self.scalemaper={}
        for e in tl:
            Radiobutton(self.scaleboxfr, text=e, value=li, variable=self.scaleselectionvar).pack(anchor=W)
            self.scalemaper[li]=e
            li+=1
        # Buttons
        self.showbutton=Button(self,text='Show', command=self.show)
        self.showbutton.pack(side=LEFT)
        self.chordbutton=Button(self,text='Open Chords', command=self.chord)
        self.chordbutton.pack(side=LEFT)
        self.quitbuttton=Button(self, text='Quit', command=self.master.quit)
        self.quitbuttton.pack(side=RIGHT)

    def show(self):
        x=Scale()
        x.doit(self.tonemaper[self.toneselectionvar.get()],self.scalemaper[self.scaleselectionvar.get()])
        self.frets.append(x)

    def chord(self):
        self.chordwindow=Chordselect()


app=Scaleselect()
app.mainloop()
